(function () {
  try {
    return angular.module('bonitasoft.ui.widgets');
  } catch(e) {
    return angular.module('bonitasoft.ui.widgets', []);
  }
})().directive('customAlaSqlOperation', function() {
    return {
      controllerAs: 'ctrl',
      controller: /**
 * The controller is a JavaScript function that augments the AngularJS scope and exposes functions that can be used in the custom widget template
 * 
 * Custom widget properties defined on the right can be used as variables in a controller with $scope.properties
 * To use AngularJS standard services, you must declare them in the main function arguments.
 * 
 * You can leave the controller empty if you do not need it.
 */
function pbAlaSqlCtrl($scope) {
    
    var ctrl=this;
    var vm=this;
    
    
    this.exportExcel = function()
    {
        var mystyle = {
				headers:true,
				columns: [],
		};
		
		mystyle.columns = [ 
		    { 'columnid': 'name', 'title': 'Name of the company'},
		    { 'columnid': 'adresse', 'title': 'Address'}
        ];
		    
		var dataJson = [ 
		    {"name": "Bonitasoft", "adresse":"51 rue gustave Eiffel"},
		    {"name": "Imagina international"},
		    {"name": "Cap Gemini"},
		       
		]
      console.log("widget alaSql: export filename:"+$scope.properties.fileNameExported)
       alasql('SELECT * INTO XLS(?,?) FROM ?', [$scope.properties.fileNameExported,$scope.properties.controlExport, $scope.properties.dataExport]);
    }
    
    // --------------------------------- Import
    this.init = function( )
    {
         $scope.properties.valueImported=[];
         console.log("widget-alasqlOperation: Init");
    }
    this.init();
    
    // see https://github.com/agershun/alasql/issues/971#issuecomment-360121191 to work with local file
    // http://jsfiddle.net/3ve90afo/ ==> Ouah!
    this.jsonloaded=[];
    this.errorImport ='';
    this.statusImport='';
    
    $scope.loadFile = function(event) {
	    console.log("alasqlOperation: loadFile");
        var self=ctrl;
        self.errorImport="";
        self.statusImport="Start loading;";
        
        $scope.properties.valueImported=[];
        $scope.properties.headerImported=[];
        $scope.properties.statusImport=self.statusImport;
        $scope.properties.errorImport=self.errorImport;



        try
        {
    	    alasql('SELECT * FROM FILE(?,{headers:true})',[event],function(data){
	    	    console.log("widget-alasqlOperation: fileNameChanged decoded");
                console.log(data);
                self.statusImport+="File detected;";
                self.updateData( angular.copy(data) );
	        });
        } catch (ex){
            self.errorImport += ex.message;
            self.statusImport += "error : "+ex.message+";";
        }
    }

  this.updateData = function ( data ) {
        // console.log(data);
        // get all the header value
         this.statusImport+="Update data;";
        var header =[];
        if (data.length>0)
        {
            var headerLine= data[ 0 ];
            this.statusImport += "Header(first line):"+angular.toJson(data[0]);
            for (var i in headerLine)
            {
                header.push( i );
                console.log("widget-alasqlOperation:Header "+i);
            }
        }
        $scope.properties.valueImported=data;
        $scope.properties.headerImported=header;
        $scope.properties.statusImport=this.statusImport;
        $scope.properties.errorImport=this.errorImport;
        console.log("widget-alasqlOperation: Header");
        console.log($scope.properties.headerImported);
        
    }
    
    this.getStatusErrorImport = function() {
        return  this.errorImport;
    }

},
      template: '<!-- The custom widget template is defined here\n   - You can use standard HTML tags and AngularJS built-in directives, scope and interpolation system\n   - Custom widget properties defined on the right can be used as variables in a templates with properties.newProperty\n   - Functions exposed in the controller can be used with ctrl.newFunction()\n   - You can use the \'environment\' property injected in the scope when inside the Editor whiteboard. It allows to define a mockup\n     of the Custom Widget to be displayed in the whiteboard only. By default the widget is represented by an auto-generated icon\n     and its name (See the <span> below).\n-->\n\n<span ng-if="environment"><identicon name="{{environment.component.id}}" size="30" background-color="[255,255,255, 0]" foreground-color="[51,51,51]"></identicon> {{environment.component.name}}</span>\n\n\n<div ng-show="properties.showImport">\n     <label\n            class="control-label col-xs">\n            {{ properties.labelImported | uiTranslate }}\n    </label>\n       \n    <div class="input-group file-upload">\n        <input type="text" ng-focus="ctrl.preventFocus($event)" placeholder="" value="" class="form-control">\n\n        <!-- ngIf: ctrl.filemodel -->\n        <span class="input-group-btn">\n            <span class="btn btn-primary btn-default btn-primary">\n                <input class="custom-file-upload-input" id="readfile" type="file" onchange="angular.element(this).scope().loadFile( event )">\n                <i class="glyphicon glyphicon-paperclip"></i>\n            </span>\n        </span>\n    </div>\n    <div><center>  <button ng-click="" class="btn btn-info">Import</button></center></div>\n    <div class="alert alert-danger" ng-show="ctrl.getStatusErrorImport().length > 0">{{ctrl.getStatusErrorImport}}</div>\n\n</div>    \n\n<!-- <div class="alert alert-info">FileModel={{properties.valueImported}}</div> -->\n\n\n<div ng-show="properties.showExport">\n    <a href=""  ng-click="ctrl.exportExcel()">\n        <img src="widgets/customalaSqlOperation/assets/img/docexcel.gif">\n        <label\n            class="control-label col-xs">\n            {{ properties.labelExported | uiTranslate }}\n        </label>\n    </a>\n</div>\n\n'
    };
  });
